---
title: List tracers for a specific agent
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Fleet Automation
---

# List tracers for a specific agent{% #list-tracers-for-a-specific-agent %}
Copy pageCopied
{% tab title="v2" %}
This endpoint is in Preview and may introduce breaking changes. If you have any feedback, contact [Datadog support](https://docs.datadoghq.com/help/).
| Datadog site      | API endpoint                                                                    |
| ----------------- | ------------------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/unstable/fleet/agents/{agent_key}/tracers |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/unstable/fleet/agents/{agent_key}/tracers |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/unstable/fleet/agents/{agent_key}/tracers      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/unstable/fleet/agents/{agent_key}/tracers      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/unstable/fleet/agents/{agent_key}/tracers  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/unstable/fleet/agents/{agent_key}/tracers     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/unstable/fleet/agents/{agent_key}/tracers |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/unstable/fleet/agents/{agent_key}/tracers |

### Overview



Retrieve a paginated list of tracers for a specific agent.

This endpoint returns tracers associated with a given agent key, identified by the agent's hostname. Use this to discover telemetry-derived service names for a particular host.
This endpoint requires the `hosts_read` permission.


### Arguments

#### Path Parameters

| Name                        | Type   | Description                                              |
| --------------------------- | ------ | -------------------------------------------------------- |
| agent_key [*required*] | string | The unique identifier (agent key) for the Datadog Agent. |

#### Query Strings

| Name            | Type    | Description                                                                        |
| --------------- | ------- | ---------------------------------------------------------------------------------- |
| page_number     | integer | Page number for pagination (starts at 0).                                          |
| page_size       | integer | Number of results per page (must be greater than 0 and less than or equal to 100). |
| sort_attribute  | string  | Attribute to sort by.                                                              |
| sort_descending | boolean | Sort order (true for descending, false for ascending).                             |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
Response containing a paginated list of fleet tracers.

| Parent field | Field                        | Type     | Description                                                              |
| ------------ | ---------------------------- | -------- | ------------------------------------------------------------------------ |
|              | data [*required*]       | object   | The response data containing status and tracers array.                   |
| data         | attributes [*required*] | object   | Attributes of the fleet tracers response containing the list of tracers. |
| attributes   | tracers                      | [object] | Array of tracers matching the query criteria.                            |
| tracers      | env                          | string   | The environment the tracer is reporting from.                            |
| tracers      | hostname                     | string   | The hostname where the tracer is running.                                |
| tracers      | language                     | string   | The programming language of the traced application.                      |
| tracers      | language_version             | string   | The version of the programming language runtime.                         |
| tracers      | remote_config_status         | string   | The remote configuration status of the tracer.                           |
| tracers      | runtime_ids                  | [string] | Runtime identifiers for the tracer instances.                            |
| tracers      | service                      | string   | The telemetry-derived service name reported by the tracer.               |
| tracers      | service_hostname             | string   | The service hostname reported by the tracer.                             |
| tracers      | service_version              | string   | The version of the traced service.                                       |
| tracers      | tracer_version               | string   | The version of the Datadog tracer library.                               |
| data         | id [*required*]         | string   | Status identifier.                                                       |
| data         | type [*required*]       | string   | Resource type.                                                           |
|              | meta                         | object   | Metadata for the list of tracers response.                               |
| meta         | total_filtered_count         | int64    | Total number of tracers matching the filter criteria across all pages.   |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "tracers": [
        {
          "env": "production",
          "hostname": "my-hostname",
          "language": "java",
          "language_version": "17.0.1",
          "remote_config_status": "connected",
          "runtime_ids": [],
          "service": "inventory-service",
          "service_hostname": "my-service-host",
          "service_version": "2.1.0",
          "tracer_version": "1.32.0"
        }
      ]
    },
    "id": "done",
    "type": "status"
  },
  "meta": {
    "total_filtered_count": 42
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="400" %}
Bad Request
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="401" %}
Unauthorized
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="403" %}
Forbidden
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="404" %}
Not Found
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export agent_key="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/unstable/fleet/agents/${agent_key}/tracers" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
List tracers for a specific agent returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.fleet_automation_api import FleetAutomationApi

configuration = Configuration()
configuration.unstable_operations["list_fleet_agent_tracers"] = True
with ApiClient(configuration) as api_client:
    api_instance = FleetAutomationApi(api_client)
    response = api_instance.list_fleet_agent_tracers(
        agent_key="agent_key",
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# List tracers for a specific agent returns "OK" response

require "datadog_api_client"
DatadogAPIClient.configure do |config|
  config.unstable_operations["v2.list_fleet_agent_tracers".to_sym] = true
end
api_instance = DatadogAPIClient::V2::FleetAutomationAPI.new
p api_instance.list_fleet_agent_tracers("agent_key")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// List tracers for a specific agent returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	configuration.SetUnstableOperationEnabled("v2.ListFleetAgentTracers", true)
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewFleetAutomationApi(apiClient)
	resp, r, err := api.ListFleetAgentTracers(ctx, "agent_key", *datadogV2.NewListFleetAgentTracersOptionalParameters())

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `FleetAutomationApi.ListFleetAgentTracers`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `FleetAutomationApi.ListFleetAgentTracers`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// List tracers for a specific agent returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.FleetAutomationApi;
import com.datadog.api.client.v2.model.FleetTracersResponse;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    defaultClient.setUnstableOperationEnabled("v2.listFleetAgentTracers", true);
    FleetAutomationApi apiInstance = new FleetAutomationApi(defaultClient);

    try {
      FleetTracersResponse result = apiInstance.listFleetAgentTracers("agent_key");
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling FleetAutomationApi#listFleetAgentTracers");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// List tracers for a specific agent returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_fleet_automation::FleetAutomationAPI;
use datadog_api_client::datadogV2::api_fleet_automation::ListFleetAgentTracersOptionalParams;

#[tokio::main]
async fn main() {
    let mut configuration = datadog::Configuration::new();
    configuration.set_unstable_operation_enabled("v2.ListFleetAgentTracers", true);
    let api = FleetAutomationAPI::with_config(configuration);
    let resp = api
        .list_fleet_agent_tracers(
            "agent_key".to_string(),
            ListFleetAgentTracersOptionalParams::default(),
        )
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * List tracers for a specific agent returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
configuration.unstableOperations["v2.listFleetAgentTracers"] = true;
const apiInstance = new v2.FleetAutomationApi(configuration);

const params: v2.FleetAutomationApiListFleetAgentTracersRequest = {
  agentKey: "agent_key",
};

apiInstance
  .listFleetAgentTracers(params)
  .then((data: v2.FleetTracersResponse) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
